/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FlowOperationFilterRule type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FlowOperationFilterRule{}

// FlowOperationFilterRule struct for FlowOperationFilterRule
type FlowOperationFilterRule struct {
	// Column ID
	Column *string `json:"column,omitempty"`
	// Comparator string (eg: ==, !=, >, <. >=, <=, in)
	Comparator *string `json:"comparator,omitempty"`
	// Value to compare with
	Value *string `json:"value,omitempty"`
}

// NewFlowOperationFilterRule instantiates a new FlowOperationFilterRule object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlowOperationFilterRule() *FlowOperationFilterRule {
	this := FlowOperationFilterRule{}
	return &this
}

// NewFlowOperationFilterRuleWithDefaults instantiates a new FlowOperationFilterRule object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowOperationFilterRuleWithDefaults() *FlowOperationFilterRule {
	this := FlowOperationFilterRule{}
	return &this
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *FlowOperationFilterRule) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFilterRule) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *FlowOperationFilterRule) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *FlowOperationFilterRule) SetColumn(v string) {
	o.Column = &v
}

// GetComparator returns the Comparator field value if set, zero value otherwise.
func (o *FlowOperationFilterRule) GetComparator() string {
	if o == nil || IsNil(o.Comparator) {
		var ret string
		return ret
	}
	return *o.Comparator
}

// GetComparatorOk returns a tuple with the Comparator field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFilterRule) GetComparatorOk() (*string, bool) {
	if o == nil || IsNil(o.Comparator) {
		return nil, false
	}
	return o.Comparator, true
}

// HasComparator returns a boolean if a field has been set.
func (o *FlowOperationFilterRule) HasComparator() bool {
	if o != nil && !IsNil(o.Comparator) {
		return true
	}

	return false
}

// SetComparator gets a reference to the given string and assigns it to the Comparator field.
func (o *FlowOperationFilterRule) SetComparator(v string) {
	o.Comparator = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *FlowOperationFilterRule) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFilterRule) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *FlowOperationFilterRule) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *FlowOperationFilterRule) SetValue(v string) {
	o.Value = &v
}

func (o FlowOperationFilterRule) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FlowOperationFilterRule) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.Comparator) {
		toSerialize["comparator"] = o.Comparator
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	return toSerialize, nil
}

type NullableFlowOperationFilterRule struct {
	value *FlowOperationFilterRule
	isSet bool
}

func (v NullableFlowOperationFilterRule) Get() *FlowOperationFilterRule {
	return v.value
}

func (v *NullableFlowOperationFilterRule) Set(val *FlowOperationFilterRule) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationFilterRule) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationFilterRule) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationFilterRule(val *FlowOperationFilterRule) *NullableFlowOperationFilterRule {
	return &NullableFlowOperationFilterRule{value: val, isSet: true}
}

func (v NullableFlowOperationFilterRule) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationFilterRule) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
